Apache log4cxx: Logger Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Logger Class Reference

Inherits AppenderAttachable, and ObjectImpl.

Inherited by RootLogger.

List of all members.

## Detailed Description

This is the central class in the log4cxx package.

Most logging operations, except configuration, are done through this class.

## Public Member Functions
| ~Logger ()
void | addRef () const
void | releaseRef () const
virtual void | addAppender (const AppenderPtr &newAppender)
| Add `newAppender` to the list of appenders of this Logger instance.
void | callAppenders (const log4cxx::spi::LoggingEventPtr &event, log4cxx::helpers::Pool &p) const
| Call the appenders in the hierrachy starting at `this`.
void | closeNestedAppenders ()
| Close all attached appenders implementing the AppenderAttachable interface.
void | debug (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the DEBUG level.
void | debug (const std::string &msg) const
| Log a message string with the DEBUG level.
void | debug (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the DEBUG level.
void | debug (const std::wstring &msg) const
| Log a message string with the DEBUG level.
void | debug (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the DEBUG level.
void | debug (const std::basic_string< UniChar > &msg) const
| Log a message string with the DEBUG level.
void | debug (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the DEBUG level.
void | debug (const CFStringRef &msg) const
| Log a message string with the DEBUG level.
void | error (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | error (const std::string &msg) const
| Log a message string with the ERROR level.
void | error (const std::wstring &msg) const
| Log a message string with the ERROR level.
void | error (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | error (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | error (const std::basic_string< UniChar > &msg) const
| Log a message string with the ERROR level.
void | error (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | error (const CFStringRef &msg) const
| Log a message string with the ERROR level.
void | fatal (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the FATAL level.
void | fatal (const std::string &msg) const
| Log a message string with the ERROR level.
void | fatal (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | fatal (const std::wstring &msg) const
| Log a message string with the ERROR level.
void | fatal (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | fatal (const std::basic_string< UniChar > &msg) const
| Log a message string with the ERROR level.
void | fatal (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the ERROR level.
void | fatal (const CFStringRef &msg) const
| Log a message string with the ERROR level.
void | forcedLog (const LevelPtr &level, const std::string &message, const log4cxx::spi::LocationInfo &location) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const std::string &message) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const std::wstring &message, const log4cxx::spi::LocationInfo &location) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const std::wstring &message) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const std::basic_string< UniChar > &message, const log4cxx::spi::LocationInfo &location) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const std::basic_string< UniChar > &message) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const CFStringRef &message, const log4cxx::spi::LocationInfo &location) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLog (const LevelPtr &level, const CFStringRef &message) const
| This method creates a new logging event and logs the event without further checks.
void | forcedLogLS (const LevelPtr &level, const LogString &message, const log4cxx::spi::LocationInfo &location) const
| This method creates a new logging event and logs the event without further checks.
bool | getAdditivity () const
| Get the additivity flag for this Logger instance.
AppenderList | getAllAppenders () const
| Get the appenders contained in this logger as an AppenderList.
AppenderPtr | getAppender (const LogString &name) const
| Look for the appender named as `name`.
virtual const LevelPtr & | getEffectiveLevel () const
| Starting from this logger, search the logger hierarchy for a non-null level and return it.
log4cxx::spi::LoggerRepositoryPtr | getLoggerRepository () const
| Return the the LoggerRepository where this `Logger` is attached.
const LogString | getName () const
| Get the logger name.
void | getName (std::string &name) const
| Get logger name in current encoding.
void | getName (std::wstring &name) const
| Get logger name.
void | getName (std::basic_string< UniChar > &name) const
| Get logger name.
void | getName (CFStringRef &name) const
| Get logger name.
LoggerPtr | getParent () const
| Returns the parent of this logger.
LevelPtr | getLevel () const
| Returns the assigned Level, if any, for this Logger.
helpers::ResourceBundlePtr | getResourceBundle () const
| Return the inherited ResourceBundle for this logger.
void | info (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the INFO level.
void | info (const std::string &msg) const
void | info (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the INFO level.
void | info (const std::wstring &msg) const
| Log a message string with the INFO level.
void | info (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the INFO level.
void | info (const std::basic_string< UniChar > &msg) const
| Log a message string with the INFO level.
void | info (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the INFO level.
void | info (const CFStringRef &msg) const
| Log a message string with the INFO level.
bool | isAttached (const AppenderPtr &appender) const
| Is the appender passed as parameter attached to this logger?
bool | isDebugEnabled () const
| Check whether this logger is enabled for the `DEBUG` Level.
bool | isEnabledFor (const LevelPtr &level) const
| Check whether this logger is enabled for a given Level passed as parameter.
bool | isInfoEnabled () const
| Check whether this logger is enabled for the info Level.
bool | isWarnEnabled () const
| Check whether this logger is enabled for the warn Level.
bool | isErrorEnabled () const
| Check whether this logger is enabled for the error Level.
bool | isFatalEnabled () const
| Check whether this logger is enabled for the fatal Level.
bool | isTraceEnabled () const
| Check whether this logger is enabled for the trace level.
void | l7dlog (const LevelPtr &level, const LogString &key, const log4cxx::spi::LocationInfo &locationInfo, const std::vector< LogString > &values) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::string &key, const log4cxx::spi::LocationInfo &locationInfo) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::string &key, const log4cxx::spi::LocationInfo &locationInfo, const std::string &val1) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::string &key, const log4cxx::spi::LocationInfo &locationInfo, const std::string &val1, const std::string &val2) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::string &key, const log4cxx::spi::LocationInfo &locationInfo, const std::string &val1, const std::string &val2, const std::string &val3) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::wstring &key, const log4cxx::spi::LocationInfo &locationInfo) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::wstring &key, const log4cxx::spi::LocationInfo &locationInfo, const std::wstring &val1) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::wstring &key, const log4cxx::spi::LocationInfo &locationInfo, const std::wstring &val1, const std::wstring &val2) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::wstring &key, const log4cxx::spi::LocationInfo &locationInfo, const std::wstring &val1, const std::wstring &val2, const std::wstring &val3) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::basic_string< UniChar > &key, const log4cxx::spi::LocationInfo &locationInfo) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::basic_string< UniChar > &key, const log4cxx::spi::LocationInfo &locationInfo, const std::basic_string< UniChar > &val1) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::basic_string< UniChar > &key, const log4cxx::spi::LocationInfo &locationInfo, const std::basic_string< UniChar > &val1, const std::basic_string< UniChar > &val2) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const std::basic_string< UniChar > &key, const log4cxx::spi::LocationInfo &locationInfo, const std::basic_string< UniChar > &val1, const std::basic_string< UniChar > &val2, const std::basic_string< UniChar > &val3) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const CFStringRef &key, const log4cxx::spi::LocationInfo &locationInfo) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const CFStringRef &key, const log4cxx::spi::LocationInfo &locationInfo, const CFStringRef &val1) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const CFStringRef &key, const log4cxx::spi::LocationInfo &locationInfo, const CFStringRef &val1, const CFStringRef &val2) const
| Log a localized and parameterized message.
void | l7dlog (const LevelPtr &level, const CFStringRef &key, const log4cxx::spi::LocationInfo &locationInfo, const CFStringRef &val1, const CFStringRef &val2, const CFStringRef &val3) const
| Log a localized and parameterized message.
void | log (const LevelPtr &level, const std::string &message, const log4cxx::spi::LocationInfo &location) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const std::string &message) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const std::wstring &message, const log4cxx::spi::LocationInfo &location) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const std::wstring &message) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const std::basic_string< UniChar > &message, const log4cxx::spi::LocationInfo &location) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const std::basic_string< UniChar > &message) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const CFStringRef &message, const log4cxx::spi::LocationInfo &location) const
| This is the most generic printing method.
void | log (const LevelPtr &level, const CFStringRef &message) const
| This is the most generic printing method.
void | logLS (const LevelPtr &level, const LogString &message, const log4cxx::spi::LocationInfo &location) const
| This is the most generic printing method.
void | removeAllAppenders ()
| Remove all previously added appenders from this logger instance.
void | removeAppender (const AppenderPtr &appender)
| Remove the appender passed as parameter form the list of appenders.
void | removeAppender (const LogString &name)
| Remove the appender with the name passed as parameter form the list of appenders.
void | setAdditivity (bool additive)
| Set the additivity flag for this Logger instance.
virtual void | setLevel (const LevelPtr &level)
| Set the level of this Logger.
void | setResourceBundle (const helpers::ResourceBundlePtr &bundle)
| Set the resource bundle to be used with localized logging methods.
void | warn (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the WARN level.
void | warn (const std::wstring &msg) const
| Log a message string with the WARN level.
void | warn (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the WARN level.
void | warn (const std::basic_string< UniChar > &msg) const
| Log a message string with the WARN level.
void | warn (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the WARN level.
void | warn (const CFStringRef &msg) const
| Log a message string with the WARN level.
void | warn (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the WARN level.
void | warn (const std::string &msg) const
| Log a message string with the WARN level.
void | trace (const std::wstring &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the TRACE level.
void | trace (const std::wstring &msg) const
| Log a message string with the TRACE level.
void | trace (const std::basic_string< UniChar > &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the TRACE level.
void | trace (const std::basic_string< UniChar > &msg) const
| Log a message string with the TRACE level.
void | trace (const CFStringRef &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the TRACE level.
void | trace (const CFStringRef &msg) const
| Log a message string with the TRACE level.
void | trace (const std::string &msg, const log4cxx::spi::LocationInfo &location) const
| Log a message string with the TRACE level.
void | trace (const std::string &msg) const
| Log a message string with the TRACE level.
const log4cxx::helpers::Mutex & | getMutex () const
## Static Public Member Functions
static LoggerPtr | getLogger (const std::string &name)
| Retrieve a logger by name in current encoding.
static LoggerPtr | getLogger (const char *const name)
| Retrieve a logger by name in current encoding.
static LoggerPtr | getLogger (const std::wstring &name)
| Retrieve a logger by name.
static LoggerPtr | getLogger (const wchar_t *const name)
| Retrieve a logger by name.
static LoggerPtr | getLogger (const std::basic_string< UniChar > &name)
| Retrieve a logger by name.
static LoggerPtr | getLogger (const CFStringRef &name)
| Retrieve a logger by name.
static LoggerPtr | getLoggerLS (const LogString &name)
| Retrieve a logger by name in Unicode.
static LoggerPtr | getRootLogger ()
| Retrieve the root logger.
static LoggerPtr | getLoggerLS (const LogString &name, const log4cxx::spi::LoggerFactoryPtr &factory)
| Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter.
static LoggerPtr | getLogger (const std::string &name, const log4cxx::spi::LoggerFactoryPtr &factory)
| Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter.
static LoggerPtr | getLogger (const std::wstring &name, const log4cxx::spi::LoggerFactoryPtr &factory)
| Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter.
static LoggerPtr | getLogger (const std::basic_string< UniChar > &name, const log4cxx::spi::LoggerFactoryPtr &factory)
| Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter.
static LoggerPtr | getLogger (const CFStringRef &name, const log4cxx::spi::LoggerFactoryPtr &factory)
| Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter.
## Protected Member Functions
| Logger (log4cxx::helpers::Pool &pool, const LogString &name)
| This constructor created a new `logger` instance and sets its name.
LogString | getResourceBundleString (const LogString &key) const
| Returns the string resource coresponding to `key` in this logger's inherited resource bundle.
void | setHierarchy (spi::LoggerRepository *repository)
| Only the Hierarchy class can set the hierarchy of a logger.
## Protected Attributes
LogString | name
| The name of this logger.
LevelPtr | level
| The assigned level of this logger.
LoggerPtr | parent
| The parent of this logger.
helpers::ResourceBundlePtr | resourceBundle
| The resourceBundle for localized messages.
log4cxx::spi::LoggerRepository * | repository
helpers::AppenderAttachableImplPtr | aai
bool | additive
| Additivity is set to true by default, that is children inherit the appenders of their ancestors by default.
## Friends
class | DefaultLoggerFactory
class | Hierarchy
class | log4cxx::helpers::synchronized

## Constructor & Destructor Documentation

Logger | ( | log4cxx::helpers::Pool & | pool,
|  | const LogString & | name
| ) | `[protected]`

  | This constructor created a new `logger` instance and sets its name. It is intended to be used by sub-classes only. You should not create categories directly. Parameters:
  | pool | lifetime of pool must be longer than logger.
  | name | The name of the logger.

~Logger | ( |  | ) |

## Member Function Documentation

virtual void addAppender | ( | const AppenderPtr & | newAppender | ) | `[virtual]`

| Add `newAppender` to the list of appenders of this Logger instance. If `newAppender` is already in the list of appenders, then it won't be added again. Implements AppenderAttachable.

void addRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

void callAppenders | ( | const log4cxx::spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & | p
| ) | const

  | Call the appenders in the hierrachy starting at `this`. If no appenders could be found, emit a warning. This method calls all the appenders inherited from the hierarchy circumventing any evaluation of whether to log or not to log the particular log request. Parameters:
  | event | the event to log.
  | p | memory pool for any allocations needed to process request.

void closeNestedAppenders | ( |  | ) |

| Close all attached appenders implementing the AppenderAttachable interface.

void debug | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void debug | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void debug | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void debug | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void debug | ( | const std::wstring & | msg | ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void debug | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void debug | ( | const std::string & | msg | ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void debug | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the DEBUG level. This method first checks if this logger is `DEBUG` enabled by comparing the level of this logger with the DEBUG level. If this logger is `DEBUG` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void error | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void error | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void error | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void error | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void error | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void error | ( | const std::wstring & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void error | ( | const std::string & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void error | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void fatal | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void fatal | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void fatal | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void fatal | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void fatal | ( | const std::wstring & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void fatal | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void fatal | ( | const std::string & | msg | ) | const

  | Log a message string with the ERROR level. This method first checks if this logger is `ERROR` enabled by comparing the level of this logger with the ERROR level. If this logger is `ERROR` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void fatal | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the FATAL level. This method first checks if this logger is `FATAL` enabled by comparing the level of this logger with the FATAL level. If this logger is `FATAL` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void forcedLog | ( | const LevelPtr & | level,
|  | const CFStringRef & | message
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.

void forcedLog | ( | const LevelPtr & | level,
|  | const CFStringRef & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.
  | location | location of source of logging request.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | message
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.
  | location | location of source of logging request.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::wstring & | message
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::wstring & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.
  | location | location of source of logging request.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::string & | message
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.

void forcedLog | ( | const LevelPtr & | level,
|  | const std::string & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | message.
  | location | location of source of logging request.

void forcedLogLS | ( | const LevelPtr & | level,
|  | const LogString & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This method creates a new logging event and logs the event without further checks. Parameters:
  | level | the level to log.
  | message | the message string to log.
  | location | location of the logging statement.

bool getAdditivity | ( |  | ) | const

| Get the additivity flag for this Logger instance.

AppenderList getAllAppenders | ( |  | ) | const`[virtual]`

| Get the appenders contained in this logger as an AppenderList. If no appenders can be found, then an empty AppenderList is returned. Returns: AppenderList An collection of the appenders in this logger. Implements AppenderAttachable.

AppenderPtr getAppender | ( | const LogString & | name | ) | const`[virtual]`

| Look for the appender named as `name`. Return the appender with that name if in the list. Return `NULL` otherwise. Implements AppenderAttachable.

virtual const LevelPtr& getEffectiveLevel | ( |  | ) | const`[virtual]`

  | Starting from this logger, search the logger hierarchy for a non-null level and return it. The Logger class is designed so that this method executes as quickly as possible. Exceptions:
  | RuntimeException | if all levels are null in the hierarchy
Reimplemented in RootLogger.

LevelPtr getLevel | ( |  | ) | const

| Returns the assigned Level, if any, for this Logger. Returns: Level - the assigned Level, can be null.

static LoggerPtr getLogger | ( | const CFStringRef & | name,
|  | const log4cxx::spi::LoggerFactoryPtr & | factory
| ) | `[static]`

  | Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter. This method is intended to be used by sub-classes. Parameters:
  | name | The name of the logger to retrieve.
  | factory | A LoggerFactory implementation that will actually create a new Instance.

static LoggerPtr getLogger | ( | const std::basic_string< UniChar > & | name,
|  | const log4cxx::spi::LoggerFactoryPtr & | factory
| ) | `[static]`

  | Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter. This method is intended to be used by sub-classes. Parameters:
  | name | The name of the logger to retrieve.
  | factory | A LoggerFactory implementation that will actually create a new Instance.

static LoggerPtr getLogger | ( | const std::wstring & | name,
|  | const log4cxx::spi::LoggerFactoryPtr & | factory
| ) | `[static]`

  | Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter. This method is intended to be used by sub-classes. Parameters:
  | name | The name of the logger to retrieve.
  | factory | A LoggerFactory implementation that will actually create a new Instance.

static LoggerPtr getLogger | ( | const std::string & | name,
|  | const log4cxx::spi::LoggerFactoryPtr & | factory
| ) | `[static]`

  | Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter. This method is intended to be used by sub-classes. Parameters:
  | name | The name of the logger to retrieve.
  | factory | A LoggerFactory implementation that will actually create a new Instance.

static LoggerPtr getLogger | ( | const CFStringRef & | name | ) | `[static]`

  | Retrieve a logger by name. Parameters:
  | name | logger name.

static LoggerPtr getLogger | ( | const std::basic_string< UniChar > & | name | ) | `[static]`

  | Retrieve a logger by name. Parameters:
  | name | logger name.

static LoggerPtr getLogger | ( | const wchar_t *const | name | ) | `[static]`

  | Retrieve a logger by name. Parameters:
  | name | logger name.

static LoggerPtr getLogger | ( | const std::wstring & | name | ) | `[static]`

  | Retrieve a logger by name. Parameters:
  | name | logger name.

static LoggerPtr getLogger | ( | const char *const | name | ) | `[static]`

  | Retrieve a logger by name in current encoding. Parameters:
  | name | logger name.

static LoggerPtr getLogger | ( | const std::string & | name | ) | `[static]`

  | Retrieve a logger by name in current encoding. Parameters:
  | name | logger name.

static LoggerPtr getLoggerLS | ( | const LogString & | name,
|  | const log4cxx::spi::LoggerFactoryPtr & | factory
| ) | `[static]`

  | Like getLogger except that the type of logger instantiated depends on the type returned by the LoggerFactory::makeNewLoggerInstance method of the `factory` parameter. This method is intended to be used by sub-classes. Parameters:
  | name | The name of the logger to retrieve.
  | factory | A LoggerFactory implementation that will actually create a new Instance.

static LoggerPtr getLoggerLS | ( | const LogString & | name | ) | `[static]`

  | Retrieve a logger by name in Unicode. Parameters:
  | name | logger name.

log4cxx::spi::LoggerRepositoryPtr getLoggerRepository | ( |  | ) | const

| Return the the LoggerRepository where this `Logger` is attached.

const log4cxx::helpers::Mutex& getMutex | ( |  | ) | const`[inline]`

void getName | ( | CFStringRef & | name | ) | const

  | Get logger name. Parameters:
  | name | buffer to which name is appended.

void getName | ( | std::basic_string< UniChar > & | name | ) | const

  | Get logger name. Parameters:
  | name | buffer to which name is appended.

void getName | ( | std::wstring & | name | ) | const

  | Get logger name. Parameters:
  | name | buffer to which name is appended.

void getName | ( | std::string & | name | ) | const

  | Get logger name in current encoding. Parameters:
  | name | buffer to which name is appended.

const LogString getName | ( |  | ) | const`[inline]`

| Get the logger name. Returns: logger name as LogString.

LoggerPtr getParent | ( |  | ) | const

| Returns the parent of this logger. Note that the parent of a given logger may change during the lifetime of the logger. The root logger will return `0`.

helpers::ResourceBundlePtr getResourceBundle | ( |  | ) | const

| Return the inherited ResourceBundle for this logger. This method walks the hierarchy to find the appropriate resource bundle. It will return the resource bundle attached to the closest ancestor of this logger, much like the way priorities are searched. In case there is no bundle in the hierarchy then `NULL` is returned.

LogString getResourceBundleString | ( | const LogString & | key | ) | const`[protected]`

| Returns the string resource coresponding to `key` in this logger's inherited resource bundle. If the resource cannot be found, then an error message will be logged complaining about the missing resource. See also: getResourceBundle.

static LoggerPtr getRootLogger | ( |  | ) | `[static]`

| Retrieve the root logger.

void info | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void info | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void info | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void info | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void info | ( | const std::wstring & | msg | ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void info | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void info | ( | const std::string & | msg | ) | const

void info | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the INFO level. This method first checks if this logger is `INFO` enabled by comparing the level of this logger with the INFO level. If this logger is `INFO` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

bool isAttached | ( | const AppenderPtr & | appender | ) | const`[virtual]`

| Is the appender passed as parameter attached to this logger? Implements AppenderAttachable.

bool isDebugEnabled | ( |  | ) | const

| Check whether this logger is enabled for the `DEBUG` Level. This function is intended to lessen the computational cost of disabled log debug statements. For some `logger` Logger object, when you write,
          logger->debug("debug message");
You incur the cost constructing the message, concatenation in this case, regardless of whether the message is logged or not. If you are worried about speed, then you should write
        if(logger->isDebugEnabled()) {
          logger->debug("debug message");
        }
This way you will not incur the cost of parameter construction if debugging is disabled for `logger`. On the other hand, if the `logger` is debug enabled, you will incur the cost of evaluating whether the logger is debug enabled twice. Once in `isDebugEnabled` and once in the `debug`. This is an insignificant overhead since evaluating a logger takes about 1%% of the time it takes to actually log. Returns: bool - `true` if this logger is debug enabled, `false` otherwise.

bool isEnabledFor | ( | const LevelPtr & | level | ) | const

| Check whether this logger is enabled for a given Level passed as parameter. See also isDebugEnabled. Returns: bool True if this logger is enabled for `level`.

bool isErrorEnabled | ( |  | ) | const

| Check whether this logger is enabled for the error Level. See also isDebugEnabled. Returns: bool - `true` if this logger is enabled for level error, `false` otherwise.

bool isFatalEnabled | ( |  | ) | const

| Check whether this logger is enabled for the fatal Level. See also isDebugEnabled. Returns: bool - `true` if this logger is enabled for level fatal, `false` otherwise.

bool isInfoEnabled | ( |  | ) | const

| Check whether this logger is enabled for the info Level. See also isDebugEnabled. Returns: bool - `true` if this logger is enabled for level info, `false` otherwise.

bool isTraceEnabled | ( |  | ) | const

| Check whether this logger is enabled for the trace level. See also isDebugEnabled. Returns: bool - `true` if this logger is enabled for level trace, `false` otherwise.

bool isWarnEnabled | ( |  | ) | const

| Check whether this logger is enabled for the warn Level. See also isDebugEnabled. Returns: bool - `true` if this logger is enabled for level warn, `false` otherwise.

void l7dlog | ( | const LevelPtr & | level,
|  | const CFStringRef & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const CFStringRef & | val1,
|  | const CFStringRef & | val2,
|  | const CFStringRef & | val3
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
  | val3 | The value for the third placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const CFStringRef & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const CFStringRef & | val1,
|  | const CFStringRef & | val2
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const CFStringRef & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const CFStringRef & | val1
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const CFStringRef & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::basic_string< UniChar > & | val1,
|  | const std::basic_string< UniChar > & | val2,
|  | const std::basic_string< UniChar > & | val3
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
  | val3 | The value for the third placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::basic_string< UniChar > & | val1,
|  | const std::basic_string< UniChar > & | val2
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::basic_string< UniChar > & | val1
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::wstring & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::wstring & | val1,
|  | const std::wstring & | val2,
|  | const std::wstring & | val3
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
  | val3 | The value for the third placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::wstring & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::wstring & | val1,
|  | const std::wstring & | val2
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::wstring & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::wstring & | val1
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::wstring & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::string & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::string & | val1,
|  | const std::string & | val2,
|  | const std::string & | val3
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The value for the first placeholder within the pattern.
  | val2 | The value for the second placeholder within the pattern.
  | val3 | The value for the third placeholder within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::string & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::string & | val1,
|  | const std::string & | val2
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The first value for the placeholders within the pattern.
  | val2 | The second value for the placeholders within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::string & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::string & | val1
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | val1 | The first value for the placeholders within the pattern.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const std::string & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
See also: setResourceBundle

void l7dlog | ( | const LevelPtr & | level,
|  | const LogString & | key,
|  | const log4cxx::spi::LocationInfo & | locationInfo,
|  | const std::vector< LogString > & | values
| ) | const

  | Log a localized and parameterized message. First, the user supplied `key` is searched in the resource bundle. Next, the resulting pattern is formatted using helpers::StringHelper::format method with the user supplied string array `params`. Parameters:
  | level | The level of the logging request.
  | key | The key to be searched in the ResourceBundle.
  | locationInfo | The location info of the logging request.
  | values | The values for the placeholders `{0}`, `{1}` etc. within the pattern.
See also: setResourceBundle

void log | ( | const LevelPtr & | level,
|  | const CFStringRef & | message
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.

void log | ( | const LevelPtr & | level,
|  | const CFStringRef & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.
  | location | The source file of the logging request, may be null.

void log | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | message
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.

void log | ( | const LevelPtr & | level,
|  | const std::basic_string< UniChar > & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.
  | location | The source file of the logging request, may be null.

void log | ( | const LevelPtr & | level,
|  | const std::wstring & | message
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.

void log | ( | const LevelPtr & | level,
|  | const std::wstring & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.
  | location | The source file of the logging request, may be null.

void log | ( | const LevelPtr & | level,
|  | const std::string & | message
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.

void log | ( | const LevelPtr & | level,
|  | const std::string & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.
  | location | The source file of the logging request, may be null.

void logLS | ( | const LevelPtr & | level,
|  | const LogString & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | This is the most generic printing method. It is intended to be invoked by wrapper classes. Parameters:
  | level | The level of the logging request.
  | message | The message of the logging request.
  | location | The source file of the logging request, may be null.

void releaseRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

void removeAllAppenders | ( |  | ) | `[virtual]`

| Remove all previously added appenders from this logger instance. This is useful when re-reading configuration information. Implements AppenderAttachable.

void removeAppender | ( | const LogString & | name | ) | `[virtual]`

| Remove the appender with the name passed as parameter form the list of appenders. Implements AppenderAttachable.

void removeAppender | ( | const AppenderPtr & | appender | ) | `[virtual]`

| Remove the appender passed as parameter form the list of appenders. Implements AppenderAttachable.

void setAdditivity | ( | bool | additive | ) |

| Set the additivity flag for this Logger instance.

void setHierarchy | ( | spi::LoggerRepository * | repository | ) | `[protected]`

| Only the Hierarchy class can set the hierarchy of a logger.

virtual void setLevel | ( | const LevelPtr & | level | ) | `[virtual]`

| Set the level of this Logger. As in
        logger->setLevel(Level::getDebug());
Null values are admitted. Reimplemented in RootLogger.

void setResourceBundle | ( | const helpers::ResourceBundlePtr & | bundle | ) | `[inline]`

| Set the resource bundle to be used with localized logging methods.

void trace | ( | const std::string & | msg | ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void trace | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void trace | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void trace | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void trace | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void trace | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void trace | ( | const std::wstring & | msg | ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void trace | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the TRACE level. This method first checks if this logger is `TRACE` enabled by comparing the level of this logger with the TRACE level. If this logger is `TRACE` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void warn | ( | const std::string & | msg | ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void warn | ( | const std::string & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void warn | ( | const CFStringRef & | msg | ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void warn | ( | const CFStringRef & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void warn | ( | const std::basic_string< UniChar > & | msg | ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void warn | ( | const std::basic_string< UniChar > & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

void warn | ( | const std::wstring & | msg | ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.

void warn | ( | const std::wstring & | msg,
|  | const log4cxx::spi::LocationInfo & | location
| ) | const

  | Log a message string with the WARN level. This method first checks if this logger is `WARN` enabled by comparing the level of this logger with the WARN level. If this logger is `WARN` enabled, it proceeds to call all the registered appenders in this logger and also higher in the hierarchy depending on the value of the additivity flag. Parameters:
  | msg | the message string to log.
  | location | location of source of logging request.

## Friends And Related Function Documentation

friend class DefaultLoggerFactory`[friend]`

friend class Hierarchy`[friend]`

friend class log4cxx::helpers::synchronized`[friend]`

## Member Data Documentation

helpers::AppenderAttachableImplPtr aai`[protected]`

bool additive`[protected]`

| Additivity is set to true by default, that is children inherit the appenders of their ancestors by default. If this variable is set to `false` then the appenders found in the ancestors of this logger are not used. However, the children of this logger will inherit its appenders, unless the children have their additivity flag set to `false` too. See the user manual for more details.

LevelPtr level`[protected]`

| The assigned level of this logger. The `level` variable need not be assigned a value in which case it is inherited form the hierarchy.

LogString name`[protected]`

| The name of this logger.

LoggerPtr parent`[protected]`

| The parent of this logger. All loggers have at least one ancestor which is the root logger.

log4cxx::spi::LoggerRepository* repository`[protected]`

helpers::ResourceBundlePtr resourceBundle`[protected]`

| The resourceBundle for localized messages. See also: setResourceBundle, getResourceBundle

The documentation for this class was generated from the following file:

- logger.h